function sales_in_the_week (widget) {
    "use strict";

    widget.SalesInTheWeekWidget = widget.Base.extend({
        template: 'SalesInTheWeekTmpl',
        data: [],
        init: function (parent) {
            this._super(parent, {
                width: 6,
                height: 4
            });
        },
        start: function () {
            var chart = new Chart(this.$el.find('#sales-in-the-week'), {
                type: 'line',
                data: {
                    labels: ["Domingo", "Lunes", "Martes", "Miércoles", "Jueves", "Viernes", "Sábado"],
                    datasets: [
                        {
                            fill: false,
                            lineTension: 0,
                            backgroundColor: "#7c7bad",
                            pointBorderColor: "#7c7bad",
                            pointHoverRadius: 5,
                            pointHoverBackgroundColor: "#7c7bad",
                            pointHoverBorderColor: "rgba(220,220,220,1)",
                            pointHoverBorderWidth: 2,
                            pointRadius: 1,
                            pointHitRadius: 10,
                            data: [65, 59, 80, 81, 56, 55, 40],
                        }
                    ]
                },
                options: {
                    maintainAspectRatio: false,
                    layout: {
                        padding: 20
                    },
                    legend: {
                        display: false
                    }
                }
            });
        },
        getSales: function () {
            var Sale = new instance.web.Model('sale.order');
            return Sale.query(['name']).order_by(['id']).all();
        }
    });
}
